#!/usr/bin/sh

# OS info
os=`uname -s`
rel=`uname -r`
ver=`uname -r`
arch=`uname -p`
platform=""
case $os in
	AIX)
		platform="aix$ver.$rel"
		;;
	SunOS)
		case $rel in
			5.10)
				platform="sol10"
				;;
		esac
		;;
esac

# User and group info
user="nagios"
uid=-1
group="nagios"
gid=-1

# Directories
case $os in
	AIX|HP-UX|SunOS)
		prefix="/opt/nagios"
		nrdpdir="$prefix/nrdp"
		userhome="$prefix"
		;;
	Darwin|Linux)
		prefix="/usr/local/nagios"
		nrdpdir="/usr/local/nrdp"
		userhome="/home/$user"
		;;
esac
libexecdir="$prefix/libexec"
sysconfdir="/etc/nagios"

# File locations
case $os in
	AIX)
		cronallow="/var/adm/cron/cron.allow"
		crondeny="/var/adm/cron/cron.deny"
		;;
	Darwin)
		cronallow="/usr/lib/cron/cron.allow"
		crondeny="/usr/lib/cron/cron.deny"
		;;
	HP-UX)
		cronallow="/usr/lib/cron/cron.allow"
		crondeny="/usr/lib/cron/cron.deny"
		;;
	Linux)
		cronallow="/etc/cron.allow"
		crondeny="/etc/cron.deny"
		;;
	SunOS)
		cronallow="/etc/cron.d/cron.allow"
		crondeny="/etc/cron.d/cron.deny"
		;;
esac

# Binary locations
cp_fr="cp -fr"
case $os in
	AIX)
		binpath="/usr/bin:/usr/sbin:/opt/freeware/bin"
		;;
	Darwin)
		binpath="/bin:/usr/bin:/bin:/usr/sbin:/opt/local/bin"
		cp_fr="cp -fR"
		;;
	HP-UX)
		binpath="/usr/bin:/usr/local/bin"
		;;
	Linux)
		binpath="/bin:/usr/bin:/usr/sbin"
		;;
	SunOS)
		binpath="/usr/bin:/usr/sbin:/usr/sfw/bin"
		;;
esac
PATH="$binpath"
export PATH
