'# Developed by: Yancy Ribbens (yribbens@nagios.com)
'# Copyright (c) 2010-2011 Nagios Enterprises, LLC.

'#Creates scheduled task on Windows2008 Compatible Systems
'#Uses NRDS_win.xml as a template to create a new XML file
'#Imports new XML file into task scheduler

'Version 1.01

On Error Resume Next
TaskName = WScript.Arguments(0)
interval = WScript.Arguments(1)
path = Wscript.Arguments(2)

Set objShell = createobject( "Wscript.Shell" )
tempd = objShell.ExpandEnvironmentStrings( "%TEMP%" )
set fso = CreateObject("Scripting.FileSystemObject")
debug_file = tempd & "\" & "install_debug.nrds"

set outFile = fso.CreateTextFile(debug_file,True)

outFile.WriteLine("TaskName = " & TaskName)
outFile.WriteLine("interval = " & interval)
outFile.WriteLine("path = " & path)

'function for formatting time in format yyyy-dd-mmThh:mm:ss
Function FormDateTime()
	currDateTime = now
	dyear = (DatePart("yyyy",currDateTime))
	dday = (DatePart("d",currDateTime))
	dmonth = (DatePart("m",currDateTime))
	
	if dday < 10 then
		dday = Right(String(2, "0") & dday,2)
	end if
	
	if dmonth < 10 then
		dmonth = Right(String(2, "0") & dmonth,2)
	end if
	
	FormatDate = dyear & "-" & dmonth & "-" & dday

	HM = FormatDateTime(currDateTime, 4)
	S = (Second(currDateTime))

	if Len(S) < 2 Then
		S = 0 & S
	end if

	T = HM & ":" & S
	
	datetime = FormatDate & "T" & T
	
	FormDateTime = datetime
End Function

'returns working directory
Function SetCommand( path )
	set fso = CreateObject("Scripting.FileSystemObject")

	Set FsoFolder = fso.GetFolder( path )
	ShortPathName = FsoFolder.ShortPath
	
	SetCommand = ShortPathName
End Function


'function to return current user
Function GetUsr()
	Set wshNetwork = CreateObject("WScript.Network")
	if Err.Number <> 0 Then
		currentUsr = "DrWho"
	Else currentUsr = wshNetwork.Username
	End if
	
	GetUsr = currentUsr
End Function

'define variables
FormedDateTime = FormDateTime()
CurrentUsr = GetUsr()
StartBoundaryVal = Left(formedDateTime, 17) &  "00"
ExecFile = "NRDS_Win.vbs"
ShortPathName = SetCommand( path )
Command = ShortPathName & "\" & ExecFile
interval = "PT" & interval & "M"
installPath = path & "\install"
baseXML = installPath & "\NRDS_win.xml"

outFile.WriteLine("datetime = " & datetime)

'Makes new XML file for use by Task Scheduler
Function CreateXML()
	Set xmlDoc = _
		CreateObject("Microsoft.XMLDOM")

	xmlDoc.Async = "False"
	xmlDoc.Load(baseXML)

	'change XML date to current date
	Set colNodes = xmlDoc.selectNodes("/Task/RegistrationInfo/Date")
	for each objNode in colNodes
		objNode.Text = FormedDateTime
	Next

	'change XML user to current user
	Set colNodes = xmlDoc.selectNodes("/Task/RegistrationInfo/Author")
	for each objNode in colNodes
		objNode.Text = CurrentUsr
	Next

	'change XML start boundary time
	Set colNodes = xmlDoc.selectNodes("/Task/Triggers/TimeTrigger/StartBoundary")
	for each objNode in colNodes
		objNode.Text = StartBoundaryVal
	Next

	'change XML command to execute
	Set colNodes = xmlDoc.selectNodes("/Task/Actions/Exec/Command")
	for each objNode in colNodes
		objNode.Text = Command
	Next

	Set colNodes = xmlDoc.selectNodes("/Task/Actions/Exec/WorkingDirectory")
	for each objNode in colNodes
		objNode.Text = ShortPathName
	Next
	
	Set colNodes = xmlDoc.selectNodes("/Task/Triggers/TimeTrigger/Repetition/Interval")
	for each objNode in colNodes
		objNode.Text = interval
	Next
	
	Set objFSO = CreateObject( "Scripting.FileSystemObject" )
	
	if objFSO.Fileexists( NRDS_Task ) then
		objFSO.DeleteFile NRDS_Task
	End if
	
	xmlDoc.Save tempd & "\NRDS_win_gen.xml"
End Function

'Uses new XML data to create scheduled task
Function PlugTask()
	NRDS_Task = tempd & "\NRDS_win_gen.xml"
	
	createTask = "schtasks /create /f /xml "
	createTask = createTask & NRDS_Task
	createTask = createTask & " /tn "
	createTask = createTask & """"
	createTask = createTask & TaskName
	createTask = createTask & """"

	objShell.run createTask,0,True
	
	outFile.WriteLine("cmd run = " & createTask)
End Function

CreateXML()
PlugTask()